# FindGLFW3.cmake
# This file will be used by find_package(FreeImage) to find the FreeImage-Library in CMake Projects
#
# Variables that will be set:
# - GLFW_FOUND			Whether FREEIMAGE could be found
# - GLFW_INCLUDE_DIR	The FREEIMAGE Include-Directory
# - GLFW_LIBRARIES		The FREEIMAGE-Libraries you need to link


#Include
find_path(GLFW_INCLUDE_DIR GLFW/glfw3.h
			PATH_SUFFIXES include
)


# Library
find_library(GLFW_DEBUG glfw3d
			PATH_SUFFIXES lib)
find_library(GLFW_RELEASE glfw3
			PATH_SUFFIXES lib)
			
SET(GLFW_LIBRARIES "optimized;${GLFW_RELEASE};debug;${GLFW_DEBUG}" CACHE STRING "The GLFW-Libraries")


# FREEIMAGE_FOUND and other stuff
INCLUDE(FindPackageHandleStandardArgs)
find_package_handle_standard_args(
	GLFW DEFAULT_MSG
	GLFW_INCLUDE_DIR GLFW_DEBUG GLFW_RELEASE
)
mark_as_advanced(GLFW_DEBUG GLFW_RELEASE)